
BW.Config = {}
function BW.Config.Create()
    -- http://wowwiki.wikia.com/wiki/Using_the_Interface_Options_Addons_panel
    local addon = {}
    
    addon.panel = CreateFrame("Frame", "BWPanel", UIParent)
    -- Register in the Interface Addon Options GUI
    -- Set the name for the Category for the Options Panel
    addon.panel.name = "Bank's Watch"
    addon.panel.title = addon.panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
    addon.panel.title:SetFont(addon.panel.title:GetFont(), 16) -- Resize string
    addon.panel.title:SetText("Bank's Watch")
    addon.panel.title:SetPoint("TOPLEFT", 15, -25)

    addon.panel.support = addon.panel:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
    addon.panel.support:SetPoint("TOPLEFT", addon.panel.title, "BOTTOMLEFT", 0, -10)
    addon.panel.support:SetText("Support this free project by sharing Bank's Watch with your friends.")
    addon.panel.support:SetTextColor(1, 1, 1)

    -- Add the panel to the Interface Options
    addon.panel.iconsize = BW_iconsizeslider(addon.panel)
    addon.panel.iconrow = BW_iconrowslider(addon.panel)
    addon.panel.minimize = BW_minimizecheckbox(addon.panel)
    addon.panel.reload = BW_reloaduibutton(addon.panel, "Reload UI")

    InterfaceOptions_AddCategory(addon.panel)
end

function BW_iconsizeslider(parent)

    local BWslider = CreateFrame("Slider", "BWiconsizeslider", parent, "OptionsSliderTemplate")
    BWslider:SetWidth(200)
    BWslider:SetHeight(16)
    BWslider:SetPoint("TOPLEFT", 25, -100)
    BWiconsizesliderLow:SetText("25")
    BWiconsizesliderHigh:SetText("40")
    BWslider:SetMinMaxValues(25, 40)
    BWslider:SetValueStep(1)
    BWslider:SetValue(BWsavedtable['iconsizeslider'] and tonumber(BWsavedtable['iconsizeslider']) or 32)
    BWiconsizesliderText:SetFormattedText("Icon size: %d (Default: 32)", BWslider:GetValue())
    BWslider:SetScript("OnValueChanged", function(self, value)
        BWiconsizesliderText:SetFormattedText("Icon size: %d (Default: 32)", value)
        BWsavedtable['iconsize'] = math.floor(value + 0.5)
        BWsavedtable['iconsizeslider'] = value
    end)
    return BWslider
end

function BW_iconrowslider(parent)

    local BWslider = CreateFrame("Slider", "BWiconrowslider", parent, "OptionsSliderTemplate")
    BWslider:SetWidth(200)
    BWslider:SetHeight(16)
    BWslider:SetPoint("TOPLEFT", 25, -150)
    BWiconrowsliderLow:SetText("10")
    BWiconrowsliderHigh:SetText("20")
    BWslider:SetMinMaxValues(10, 20)
    BWslider:SetValueStep(1)
    BWslider:SetValue(BWsavedtable['iconrowslider'] and tonumber(BWsavedtable['iconrowslider']) or 12)
    BWiconrowsliderText:SetFormattedText("Icons per row: %d (Default: 12)", BWslider:GetValue())
    BWslider:SetScript("OnValueChanged", function(self, value)
        BWiconrowsliderText:SetFormattedText("Icons per row: %d (Default: 12)", value)
        BWsavedtable['iconrow'] = math.floor(value + 0.5)
        BWsavedtable['iconrowslider'] = value
    end)
    return BWslider
end

function BW_minimizecheckbox(parent)

    local checkbox = CreateFrame("CheckButton", "BWminimizecheckbox", parent, "InterfaceOptionsCheckButtonTemplate")
    checkbox:SetPoint("TOPLEFT", 25, -200)
    checkbox:SetHitRectInsets(0, -300, 0, 0)
    BWminimizecheckboxText:SetText("Start Bank's Watch minimized")
    checkbox:SetChecked(BWsavedtable['minimize'] or false)
    checkbox:SetScript("OnClick", function(self) 
        if self:GetChecked() then
            BWsavedtable['minimize'] = true
        else
            BWsavedtable['minimize'] = false
        end
    end)
    return checkbox
end

function BW_reloaduibutton(parent, text)

    local label = parent:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
    label:SetPoint("TOPLEFT", parent, 25, -250)
    label:SetText("*To take effect, all changes require reloading your UI.")
    label:SetTextColor(1, 0, 0)

    local button = CreateFrame("Button", nil, parent, "UIPanelbuttontemplate")
    button:SetText(text)
    button:SetWidth(100)
    button:SetHeight(32)
    button:SetPoint("TOPLEFT", 25, -265)
    button.label = label

    button:SetScript("OnClick", function(self) ReloadUI() end)
    BWI.GradientButton.Create(button, "VERTICAL")
    return button
end
